//-----------------------------------------------
//TUSB-1612ADSM-SphCoANZXpAPI
//Visual C++/CLI pW[
//
//2014_02_04@Ѓ^[gH
//Copyright (C) 2013 Turtle Industry Co.,Ltd.
//-----------------------------------------------

#ifndef USBADSMS_h
#define USBADSMS_h

using namespace System;
using namespace System::Runtime::InteropServices;

// A荞ݐݒp\̐錾
[StructLayout(LayoutKind::Sequential)] value struct adsms_setting
//struct adsms_setting
{
    unsigned char ChLen; //`l 1-16
    [MarshalAs(UnmanagedType::ByValArray, SizeConst = 16)]
	array<unsigned char> ^ ChPattern;
    [MarshalAs(UnmanagedType::ByValArray, SizeConst = 16)]
	array<unsigned char> ^ ChPatternRange;
    unsigned char TriggerType; //gKށ@1:\tg@2:OfBW^ 3:OfBW^ 4:GbW 5:GbW@6:x@7:x
    short TriggerLevel; //GbW⃌x臒l
    unsigned char TriggerCh; //GbW⃌xo`lʒu(p^[obt@̃|C^)
    unsigned char ClockSel; //0:NbN@1:ONbN
    int SamplingClock; //NbNԊu 10`16,777,215[uS]
    int PreTriggerLen; //vgK 0`10,000,000
    int TotalLen; //S捞f[^obt@ 1`10,000,000
};

[DllImport("TUSADSMS.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadsms_Device_Open(short id);
[DllImport("TUSADSMS.DLL", CallingConvention = CallingConvention::Cdecl)]
extern void Tusbadsms_Device_Close(short id);
[DllImport("TUSADSMS.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadsms_Pio_Write(short id, unsigned char dat);
[DllImport("TUSADSMS.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadsms_Pio_Read(short id, unsigned char *dat);
[DllImport("TUSADSMS.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadsms_Single_Sample(short id, unsigned char ch, unsigned char range, short *dat);
[DllImport("TUSADSMS.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadsms_Status_Read(short id, unsigned char *status, unsigned char *ovf, int *leng);
[DllImport("TUSADSMS.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadsms_Memory_Read(short id, [Out] short Data[], int *leng);
[DllImport("TUSADSMS.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadsms_Sampling_Stop(short id);
[DllImport("TUSADSMS.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadsms_Memory_Clear(short id);
[DllImport("TUSADSMS.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadsms_Sampling_Trigger(short id);
[DllImport("TUSADSMS.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadsms_Sample_Start(short id, [In] adsms_setting smplset);

static String^ Tusbadsms_GetErrMessage(short retcode)
{
    switch (retcode)
    {
        case 0:
            return "I܂";
        case 1:
            return "IDԍsł";
        case 2:
            return "hCoCXg[Ă܂";
        case 3:
            return "łɃfoCX̓I[vĂ܂";
        case 4:
            return "ڑĂ䐔܂";
        case 5:
            return "I[vł܂ł";
        case 6:
            return "foCX݂܂";
        case 7:
            return "I[vĂ܂";
        case 8:
            return "p[^G[";
        case 9:
            return "USBʐMG[ł";
        default:
            return "sȃG[ł";
    }
}

#endif
